routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'NewsController@index')->name('home')->middleware('auth');

Route::resource('users','UsersController')->only('show')->middleware('auth');
Route::resource('news','NewsController')->middleware('auth');
Route::resource('news.comments', 'CommentsController')->except('index', 'show')->middleware('auth');
Route::post('rating/news/{news}', 'NewsController@rating')->name('rating')->middleware('auth');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Comment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class Comment extends Model
{
    protected $fillable = ['user_id', 'news_id', 'body'];

    /**
     * @return BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function news() {
        return $this->belongsTo(News::class);
    }

}

app/Http/Controllers/CommentsController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Http\Requests\CommentRequest;
use App\News;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\View\Factory;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\Support\Facades\Auth;
use Illuminate\View\View;
use Throwable;

class CommentsController extends Controller
{
    /**
     * @param CommentRequest $request
     * @param News $news
     * @return JsonResponse
     * @throws Throwable
     */
    public function store(CommentRequest $request, News $news)
    {
        Auth::user();

        $comment = new Comment();
        $comment->body = $request->input('body');
        $comment->news_id = $news->id;
        $comment->user_id = $request->user()->id;
        $comment->save();

        return response()->json([
            'comment' => view('comments.comment', compact('comment', 'news'))->render()
        ], 201);
    }

    /**
     * @param News $news
     * @param Comment $comment
     * @return Factory|View
     */
    public function edit(News $news, Comment $comment)
    {
        return view('comments.edit', compact('comment', 'news'));
    }

    /**
     * @param CommentRequest $request
     * @param $news
     * @param Comment $comment
     * @return RedirectResponse|Redirector
     */
    public function update(CommentRequest $request, $news, Comment $comment)
    {
        $comment->update($request->all());
        return redirect(route('news.show', compact('comment', 'news')))->with('message', 'Comment updated!');
    }

    /**
     * @param $news
     * @param $id
     * @return JsonResponse
     */
    public function destroy(News $news, $id)
    {
        $comment = Comment::findOrFail($id);
        $comment->delete();
        return response()->json([
            'status' => 'ok'
        ], 200);
    }
}

resources/views/comments/comment.blade.php
<div class="media" id="delete-comment-{{$comment->id}}">
    <img class="d-flex rounded-circle mt-0 mr-3" style="width: 50px; height: 50px"
         src="{{asset('/images/default_photo.jpeg')}}" alt="Image">
    <div class="media-body">
        <div class="mb-3">
            @if($comment->user_id == Auth::user()->id || Auth::user()->is_admin)
                <input type="hidden" id="news-id" value="{{$news->id}}">
                <span data-comment-id="{{$comment->id}}" class="delete" aria-hidden="true"
                      style="float: right; font-size: 20px; color:red; cursor:pointer;"
                      value="{{$news->id}}">&times;</span>
            @endif
        </div>
        <p class="pr-4">{{$comment->body}}</p>
        <div class="comment">
            <span>Commented: {{$comment->user->name}}, </span>
            <span>{{$comment->created_at->diffForHumans()}}</span>
        </div>
        <div>
            @if($comment->user_id == Auth::user()->id || Auth::user()->is_admin)
                <a href="{{route('news.comments.edit', ['news' => $news, 'comment' => $comment])}}"
                   style="font-size: 12px">Edit</a>
            @endif
        </div>
        <hr>
    </div>
</div>

resources/views/comments/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container mt-2">
        <div class="col-10">
            <h5>Edit comment:</h5>
            <form class="mt-3" method="post" action="{{route('news.comments.update', ['comment' => $comment, 'news' => $news])}}">
                @csrf
                @method('put')
                <div class="form-row">
                    <div class="form-group col-md-10">
                        <textarea rows="5" class="form-control @error('body') is-invalid @enderror" id="body"
                                  name="body">{{$comment->body}}</textarea>
                        @error('body')
                        <p class="error">{{$message}}</p>
                        @enderror
                    </div>
                </div>
                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">Edit</button>
                <a href="{{route('news.show', ['news' => $news])}}">Back</a>
            </form>
        </div>
    </div>
@endsection